'use strict';

let starRepos = (() => {
	var _ref = _asyncToGenerator(function* (token, packageDetails) {
		const repos = packageDetails.map(function (pd) {
			return pd.repo;
		});
		const mapper = repos.map(function (repoName) {
			return ghGot(`user/starred/${repoName}`, { token, method: 'PUT' });
		});
		const response = yield pSettle(mapper);

		const successfulStars = response.map(function (x, i) {
			return Object.assign({}, x, {
				name: packageDetails[i].name
			});
		}).filter(function (resp, i) {
			const isSuccessful = resp.isFulfilled && resp.value.statusCode === 204;
			if (!isSuccessful) {
				store.setErrorRepos(packageDetails[i].name);
			}
			return resp.isFulfilled && resp.value.statusCode === 204;
		});

		const successfulStarNames = successfulStars.map(function (x) {
			return x.name;
		});

		if (!isEmpty(successfulStars)) {
			console.log(`🌟  Successfully starred ${successfulStars.length > 10 ? successfulStars.length : arrayToSentence(successfulStarNames)} ${successfulStars.length > 10 ? pluralize('repo', successfulStars.length) : ''}`);
		}
		if (!isEmpty(store.errorRepos)) {
			console.log(`${colors.red.bold('✖')} Error starring ${colors.red(arrayToSentence(store.errorRepos))}`);
		}
	});

	return function starRepos(_x, _x2) {
		return _ref.apply(this, arguments);
	};
})();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/* eslint-disable no-tabs */
const ghGot = require('gh-got');
const colors = require('colors/safe');
const pSettle = require('p-settle');
const arrayToSentence = require('array-to-sentence');
const pluralize = require('pluralize');
const isEmpty = require('just-is-empty');
const store = require('./store');

module.exports = starRepos;